/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.pac;

import java.util.List;

public class ArtifactController {
    
    //private static final transient Log LOG = LogFactory.getLog(ArtifactController.class);

    private String guid;
    private String name;
    private List<String> applicationGuids;
    
   
    public ArtifactController(String aGuid, String aName, List<String> someApplicationGuids) {
        super();
        guid = aGuid;
        name = aName;
        applicationGuids = someApplicationGuids;
    }

    protected String getGuid() {
        return guid;
    }
    protected void setGuid(String aGuid) {
        guid = aGuid;
    }
    
    protected String getName() {
        return name;
    }
    
    protected void setName(String aName) {
        name = aName;
    }
    
    protected List<String> getApplicationGuids() {
        return applicationGuids;
    }
    
    protected void setApplicationGuids(List<String> someApplicationGuids) {
        applicationGuids = someApplicationGuids;
    }
}
