/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.resourceset;

public final class QueryConstants {
    public static final char QUERY_LANGUAGE_IT_EMFQL = 'E';
    public static final char QUERY_LANGUAGE_SQL = 'S';
    public static final char QUERY_LANGUAGE_LUCENE = 'L';
    public static final String QUERY_RELOAD = "true";
    
    public static final String QUERY_LANGUAGE_PARAM_NAME = "_ql";    
    public static final String SQL_QUERY_PARAM_NAME = "q";
    
    public static final String QUERY_REGISTRY_PARAM_NAME = "registry";
    public static final String QUERY_PUBLISHER_PARAM_NAME = "publisher";
    public static final String QUERY_RELOAD_PARAM_NAME = "reload";
    
    private QueryConstants() {
    }
}
