/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.maven.util;

import org.apache.maven.embedder.ContainerCustomizer;
import org.codehaus.plexus.PlexusContainer;

public class SpiderContainerCustomizer implements ContainerCustomizer {

    public void customize(PlexusContainer container) {

        container.getComponentDescriptor("org.apache.maven.artifact.manager.WagonManager").
            setImplementation("com.iona.repository.maven.util.SpiderWagonManager");
        
        container.getComponentDescriptor("org.apache.maven.artifact.resolver.ArtifactResolver").
            setImplementation("com.iona.repository.maven.resolve.SpiderArtifactResolver");
        
 /*       container.getComponentDescriptor("org.apache.maven.artifact.Artifact").
                setImplementation("com.iona.repository.resolve.SpiderArtifact");
*/


    }
}
