/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.atom;

import org.apache.abdera.model.Feed;

public interface AtomFeedFactory {

    /**
     * Returns an Abdera Feed document.
     * @param baseUri the baseUri for the feed.
     * @param path the context path within the feed
     * @param title the title of the feed
     * @return the Abdera Feed document
     */
    Feed createFeed(String baseUri, String path, String title);
    
}
