/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.serialization;

import org.jdom.Namespace;

public final class XMLConstants {
    // Namespaces
    public static final Namespace META_NS = Namespace.getNamespace("itxml", "http://xml.emf.iona.com/");
    
    // Element names
    public static final String COLLECTION_ELEM = "collection";
    
    // Attribute names
    public static final String HREF_ATTR = "href";
    public static final String VERSION_ATTR = "version";
    public static final String TYPE_ATTR = "type";
    public static final String CONTAINER_ATTR = "eContainer";
    public static final String CONTAINER_TYPE_ATTR = "eContainerType";
    public static final String CONTAINER_FEATURE_ATTR = "eContainmentFeature";
    public static final String ACTION_ATTR = "action";
    public static final String REMOVE_ATTR = "remove";
    public static final String UNSET_ATTR = "unset";
    
    // other
    public static final String HREF_ATTR_SUFFIX = "Href";
    
    private XMLConstants() {
    }
}
