/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.status;

public enum StatusType {
    INVALID_REPLY,
    INTERNAL_SERVER_ERROR,
    REQUEST_ERROR,
    AUTHENTICATION_ERROR,
    AUTHORIZATION_ERROR,
    VALIDATION_ERROR;
    
    private final String message;
    
    StatusType() {
        message = MessageHelper.getMessage(this);
    }
    
    public String getMessage() {
        return message;
    }
}
