/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.tools;

public enum SystemProperty {
    REPOSITORY_LICENSE("com.iona.repository.license"),
    LICENSE_CONFIG_PROPERTY("repository.license"),

    REPOSITORY_SSO_SESSION_TIMEOUT("repository.sso.session.timeout"),
    REPOSITORY_SSO_SESSION_IDLE_TIMEOUT("repository.sso.session.idle.timeout"),
    REPOSITORY_SSO_CACHE_SIZE("repository.sso.cache.size"),
    
    REPOSITORY_STORAGE_LOCAL_BASE_LOCATION("com.iona.repository.storage.local.base.location"),
    REPOSITORY_STORAGE_REMOTE_BASE_LOCATION("com.iona.repository.storage.remote.base.location"),
    
    REPOSITORY_RESOURCE_RECYCLING("repository.resource.recycling");
    
    private String name;
    private SystemProperty(String name) {
        this.name = name;
    }
    
    public String toString() {
        return name;
    }
}
