/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

import com.extjs.gxt.ui.client.widget.LayoutContainer;
import com.extjs.gxt.ui.client.widget.layout.FitData;
import com.extjs.gxt.ui.client.widget.layout.FitLayout;
import com.google.gwt.user.client.ui.Widget;

public class PaddedPanel extends LayoutContainer {

    public PaddedPanel(Widget widget, int padding) {
        super();
        setAutoHeight(true);
        setAutoWidth(true);
        setBorders(false);
        setLayout(new FitLayout());
        add(widget, new FitData(padding));
    }
    
    public PaddedPanel(Widget widget, int topPadding, int rightPadding, int bottomPadding, int leftPadding) {
        super();
        setAutoHeight(true);
        setAutoWidth(true);
        setBorders(false);
        setLayout(new FitLayout());
        add(widget, new FitData(topPadding, rightPadding, bottomPadding, leftPadding));
    }
}
