/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

public enum ScheduledTaskType {   
    SPECIFIC_DATE_SELECTION("on a specific date", EClassHelper.SCHEDULED_ONCEOFF_TASK_ECLASS),
    FIXED_INTERVAL_SELECTION("at fixed intervals", EClassHelper.SCHEDULED_INTERVAL_REPEATED_TASK_ECLASS),
    EVERY_DAY_SELECTION("every day", EClassHelper.SCHEDULED_DAILY_TASK_ECLASS),
    WEEKDAY_SELECTION("on specific days of the week", EClassHelper.SCHEDULED_WEEKLY_TASK_ECLASS),
    MONTHDAY_SELECTION("on specific days of the month", EClassHelper.SCHEDULED_MONTHLY_TASK_ECLASS);
    
        
    private String name;    
    private String eclass;
    ScheduledTaskType(String name, String eclass) {                         
        this.name = name;   
        this.eclass = eclass;
        }                  
    public String toString() {                         
        return name;                 
        }       
    public String getClassName() {                         
        return eclass;                 
        }  
}

