/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository.impl;

import com.iona.soa.model.repository.RepositoryPackage;
import com.iona.soa.model.repository.Version;
import com.iona.soa.model.repository.VersionTracker;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Version</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getMajor <em>Major</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getMinor <em>Minor</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getMicro <em>Micro</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getNano <em>Nano</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getQualifier <em>Qualifier</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getTracker <em>Tracker</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.VersionImpl#getOriginalString <em>Original String</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class VersionImpl extends IPersistableObjectImpl implements Version
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getMajor() <em>Major</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMajor()
   * @generated
   * @ordered
   */
  protected static final Integer MAJOR_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getMajor() <em>Major</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMajor()
   * @generated
   * @ordered
   */
  protected Integer major = MAJOR_EDEFAULT;

  /**
   * The default value of the '{@link #getMinor() <em>Minor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinor()
   * @generated
   * @ordered
   */
  protected static final Integer MINOR_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMinor() <em>Minor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinor()
   * @generated
   * @ordered
   */
  protected Integer minor = MINOR_EDEFAULT;

  /**
   * The default value of the '{@link #getMicro() <em>Micro</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMicro()
   * @generated
   * @ordered
   */
  protected static final Integer MICRO_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMicro() <em>Micro</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMicro()
   * @generated
   * @ordered
   */
  protected Integer micro = MICRO_EDEFAULT;

  /**
   * The default value of the '{@link #getNano() <em>Nano</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNano()
   * @generated
   * @ordered
   */
  protected static final Integer NANO_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNano() <em>Nano</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNano()
   * @generated
   * @ordered
   */
  protected Integer nano = NANO_EDEFAULT;

  /**
   * The default value of the '{@link #getQualifier() <em>Qualifier</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQualifier()
   * @generated
   * @ordered
   */
  protected static final String QUALIFIER_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getQualifier() <em>Qualifier</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQualifier()
   * @generated
   * @ordered
   */
  protected String qualifier = QUALIFIER_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getTracker() <em>Tracker</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTracker()
   * @generated
   * @ordered
   */
  protected VersionTracker tracker;

  /**
   * The default value of the '{@link #getOriginalString() <em>Original String</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOriginalString()
   * @generated
   * @ordered
   */
  protected static final String ORIGINAL_STRING_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getOriginalString() <em>Original String</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOriginalString()
   * @generated
   * @ordered
   */
  protected String originalString = ORIGINAL_STRING_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected VersionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return RepositoryPackage.Literals.VERSION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getMajor() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__MAJOR);
    return _basicGetMajor();
  }
  
  private final Integer _basicGetMajor() {
    return major;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMajor(Integer newMajor)
  {
    
    Integer oldMajor = major;
    major = newMajor;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__MAJOR, oldMajor, major));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getMinor() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__MINOR);
    return _basicGetMinor();
  }
  
  private final Integer _basicGetMinor() {
    return minor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMinor(Integer newMinor)
  {
    
    Integer oldMinor = minor;
    minor = newMinor;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__MINOR, oldMinor, minor));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getMicro() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__MICRO);
    return _basicGetMicro();
  }
  
  private final Integer _basicGetMicro() {
    return micro;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMicro(Integer newMicro)
  {
    
    Integer oldMicro = micro;
    micro = newMicro;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__MICRO, oldMicro, micro));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getNano() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__NANO);
    return _basicGetNano();
  }
  
  private final Integer _basicGetNano() {
    return nano;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNano(Integer newNano)
  {
    
    Integer oldNano = nano;
    nano = newNano;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__NANO, oldNano, nano));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getQualifier() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__QUALIFIER);
    return _basicGetQualifier();
  }
  
  private final String _basicGetQualifier() {
    return qualifier;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setQualifier(String newQualifier)
  {
    
    String oldQualifier = qualifier;
    qualifier = newQualifier;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__QUALIFIER, oldQualifier, qualifier));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionTracker getTracker() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__TRACKER);
    return _basicGetTracker();
  }
  
  private final VersionTracker _basicGetTracker() {
    if (tracker != null && tracker.eIsProxy())
    {
      InternalEObject oldTracker = (InternalEObject)tracker;
      tracker = (VersionTracker)eResolveProxy(oldTracker);
      if (tracker != oldTracker)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.VERSION__TRACKER, oldTracker, tracker));
      }
    }
    return tracker;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionTracker basicGetTracker()
  {
    return tracker;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTracker(VersionTracker newTracker, NotificationChain msgs)
  {
    VersionTracker oldTracker = tracker;
    tracker = newTracker;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__TRACKER, oldTracker, newTracker);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTracker(VersionTracker newTracker)
  {
    
    if (newTracker != tracker)
    {
      NotificationChain msgs = null;
      if (tracker != null)
        msgs = ((InternalEObject)tracker).eInverseRemove(this, RepositoryPackage.VERSION_TRACKER__VERSIONS, VersionTracker.class, msgs);
      if (newTracker != null)
        msgs = ((InternalEObject)newTracker).eInverseAdd(this, RepositoryPackage.VERSION_TRACKER__VERSIONS, VersionTracker.class, msgs);
      msgs = basicSetTracker(newTracker, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__TRACKER, newTracker, newTracker));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getOriginalString() {
    autoResolveEProxy(RepositoryPackage.Literals.VERSION__ORIGINAL_STRING);
    return _basicGetOriginalString();
  }
  
  private final String _basicGetOriginalString() {
    return originalString;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOriginalString(String newOriginalString)
  {
    
    String oldOriginalString = originalString;
    originalString = newOriginalString;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.VERSION__ORIGINAL_STRING, oldOriginalString, originalString));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case RepositoryPackage.VERSION__TRACKER:
        if (tracker != null)
          msgs = ((InternalEObject)tracker).eInverseRemove(this, RepositoryPackage.VERSION_TRACKER__VERSIONS, VersionTracker.class, msgs);
        return basicSetTracker((VersionTracker)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case RepositoryPackage.VERSION__TRACKER:
        return basicSetTracker(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case RepositoryPackage.VERSION__MAJOR:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__MAJOR); }
        return _basicGetMajor();
      case RepositoryPackage.VERSION__MINOR:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__MINOR); }
        return _basicGetMinor();
      case RepositoryPackage.VERSION__MICRO:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__MICRO); }
        return _basicGetMicro();
      case RepositoryPackage.VERSION__NANO:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__NANO); }
        return _basicGetNano();
      case RepositoryPackage.VERSION__QUALIFIER:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__QUALIFIER); }
        return _basicGetQualifier();
      case RepositoryPackage.VERSION__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__DESCRIPTION); }
        return _basicGetDescription();
      case RepositoryPackage.VERSION__TRACKER:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__TRACKER); }
        if (resolve) return getTracker();
        return _basicGetTracker();
      case RepositoryPackage.VERSION__ORIGINAL_STRING:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.VERSION__ORIGINAL_STRING); }
        return _basicGetOriginalString();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case RepositoryPackage.VERSION__MAJOR:
        setMajor((Integer)newValue);
        return;
      case RepositoryPackage.VERSION__MINOR:
        setMinor((Integer)newValue);
        return;
      case RepositoryPackage.VERSION__MICRO:
        setMicro((Integer)newValue);
        return;
      case RepositoryPackage.VERSION__NANO:
        setNano((Integer)newValue);
        return;
      case RepositoryPackage.VERSION__QUALIFIER:
        setQualifier((String)newValue);
        return;
      case RepositoryPackage.VERSION__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case RepositoryPackage.VERSION__TRACKER:
        setTracker((VersionTracker)newValue);
        return;
      case RepositoryPackage.VERSION__ORIGINAL_STRING:
        setOriginalString((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case RepositoryPackage.VERSION__MAJOR:
      setMajor(MAJOR_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__MINOR:
      setMinor(MINOR_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__MICRO:
      setMicro(MICRO_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__NANO:
      setNano(NANO_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__QUALIFIER:
      setQualifier(QUALIFIER_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case RepositoryPackage.VERSION__TRACKER:
      setTracker((VersionTracker)null);
      return;
    case RepositoryPackage.VERSION__ORIGINAL_STRING:
      setOriginalString(ORIGINAL_STRING_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case RepositoryPackage.VERSION__MAJOR:
        return MAJOR_EDEFAULT == null ? major != null : !MAJOR_EDEFAULT.equals(major);
      case RepositoryPackage.VERSION__MINOR:
        return MINOR_EDEFAULT == null ? minor != null : !MINOR_EDEFAULT.equals(minor);
      case RepositoryPackage.VERSION__MICRO:
        return MICRO_EDEFAULT == null ? micro != null : !MICRO_EDEFAULT.equals(micro);
      case RepositoryPackage.VERSION__NANO:
        return NANO_EDEFAULT == null ? nano != null : !NANO_EDEFAULT.equals(nano);
      case RepositoryPackage.VERSION__QUALIFIER:
        return QUALIFIER_EDEFAULT == null ? qualifier != null : !QUALIFIER_EDEFAULT.equals(qualifier);
      case RepositoryPackage.VERSION__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case RepositoryPackage.VERSION__TRACKER:
        return tracker != null;
      case RepositoryPackage.VERSION__ORIGINAL_STRING:
        return ORIGINAL_STRING_EDEFAULT == null ? originalString != null : !ORIGINAL_STRING_EDEFAULT.equals(originalString);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (major: ");
    result.append(major);
    result.append(", minor: ");
    result.append(minor);
    result.append(", micro: ");
    result.append(micro);
    result.append(", nano: ");
    result.append(nano);
    result.append(", qualifier: ");
    result.append(qualifier);
    result.append(", description: ");
    result.append(description);
    result.append(", originalString: ");
    result.append(originalString);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //VersionImpl


