/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.configgen.loaders.serial;

import com.iona.soa.configgen.loaders.ModelConfigurationException;

@SuppressWarnings("serial")
public class SerialModelConfigurationException extends ModelConfigurationException {

    public SerialModelConfigurationException(String message) {
        super(message);
    }

    public SerialModelConfigurationException(Throwable cause) {
        super(cause);
    }

    public SerialModelConfigurationException(String message, Throwable cause) {
        super(message, cause);
    }
}
