/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.resourceset;

import java.util.Collection;

import com.iona.soa.expression.Expression;
import com.iona.soa.expression.Operation;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.ResourceSet;

public interface QueryResourceSet extends ResourceSet {
    Collection<EObject> executeQuery(EClass type, boolean resolve) throws Exception;
    Collection<EObject> executeQuery(EClass type, Operation operation, boolean resolve) throws Exception;
    Collection<EObject> executeQuery(Operation operation, boolean resolve) throws Exception;
    Collection<EObject> executeQuery(EClass type, Expression expression, boolean resolve) throws Exception;
}
