/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest;


public final class Constants {

 
    public static final String ATOM_FEED_AUTHOR = "FUSE Depot";

    public static final String ATOM_ENTRY_AUTHOR = "FUSE Depot";

    public static final String ATOM_CONTENT_TYPE = org.apache.abdera.util.Constants.ATOM_MEDIA_TYPE;

    // TODO: Need to handle these media types better.  For the moment its important to 
    // include a space after the ";" before the "type" setting.

    public static final String ATOM_ENTRY_CONTENT_TYPE
        = org.apache.abdera.util.Constants.ATOM_MEDIA_TYPE + "; type=entry";
    
    public static final String ATOM_FEED_CONTENT_TYPE 
        = org.apache.abdera.util.Constants.ATOM_MEDIA_TYPE + "; type=feed";

    public static final String RESOURCE_CONTENT_TYPE = ATOM_ENTRY_CONTENT_TYPE;

    public static final String RESOURCE_LINK_REL = "alternate";

    public static final int SUMMARY_MAX_LENGTH = 50;

    public static final String REFERENCE_LINK_REL = "related";
    
    public static final String FEED_LINK_REL = "it_feed"; // TODO: consider "alternate" instead
    
    private Constants() {
        // Complete.
    }
   
}
