/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

import com.extjs.gxt.ui.client.widget.Component;

/**
 * IContextAction extension that has a widget supplied to it by
 * the factory.  The widget is then typically used for enablement/disablement
 * based on some other criteria such as object selection. 
 */
public interface ISelectionSensitiveContextAction extends IContextAction {
    void setRenderedWidget(Component widget);
}
